Bug 2075170 - Review Request: npm - A JavaScript Package Manager
Summary: Review Request: npm - A JavaScript Package Manager
Keywords:
Status: CLOSED WONTFIX
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Neal Gompa
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2022-04-13 18:27 UTC by Stephen Gallagher
Modified: 2022-11-14 18:35 UTC (History)
2 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2022-11-14 18:35:17 UTC
Type: ---
Embargoed:
ngompa13: fedora-review+


Attachments (Terms of Use)

Description Stephen Gallagher 2022-04-13 18:27:48 UTC
Spec URL: https://copr-dist-git.fedorainfracloud.org/cgit/sgallagh/npm/npm.git/plain/npm.spec

SRPM URL: https://download.copr.fedorainfracloud.org/results/sgallagh/npm/srpm-builds/04217393/npm-8.6.0-1.fc37.src.rpm

Description:
npm is the world's largest software registry. Open source developers from
every continent use npm to share and borrow packages, and many organizations
use npm to manage private development as well.

npm consists of three distinct components:

*  the website
*  the Command Line Interface (CLI)
*  the registry

Use the [*website*](https://npmjs.com) to discover packages, set up profiles,
and manage other aspects of your npm experience. For example, you can set up
[organizations](https://www.npmjs.com/features) to manage access to public or
private packages.

The [*CLI*](https://docs.npmjs.com/cli/npm) runs from a terminal, and is how
most developers interact with npm.

The [*registry*](https://docs.npmjs.com/misc/registry) is a large public
database of JavaScript software and the meta-information surrounding it.


## Use npm to . . .

* Adapt packages of code for your apps, or incorporate packages as they are.
* Download standalone tools you can use right away.
* Run packages without downloading using
  [npx](https://www.npmjs.com/package/npx).
* Share code with any npm user, anywhere.
* Restrict code to specific developers.
* Create organizations to coordinate package maintenance, coding, and
  developers.
* Form virtual teams by using organizations.
* Manage multiple versions of code and code dependencies.
* Update applications easily when underlying code is updated.
* Discover multiple ways to solve the same puzzle.
* Find other developers who are working on similar problems and projects.

Fedora Account System Username: sgallagh

Comment 1 Stephen Gallagher 2022-04-13 18:33:15 UTC
This is a re-review request to separate out the build of 'npm' from the Node.js build.

Auto-review from COPR:

Notes:
  1) Some of the bundled contents have their own LICENSE files that are not packaged with %license. This is intentional.
  2) As noted above, this is re-reviewing to separate the package out, so the conflicting package issue below is expected.


Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- If (and only if) the source package includes the text of the license(s)
  in its own file, then that file, containing the text of the license(s)
  for the package is included in %license.
  Note: License file LICENSE.md is not marked as %license
  See: https://docs.fedoraproject.org/en-US/packaging-
  guidelines/LicensingGuidelines/#_license_text
- Package does not use a name that already exists.
  Note: A package with this name already exists. Please check
  https://src.fedoraproject.org/rpms/npm
  See: https://docs.fedoraproject.org/en-US/packaging-
  guidelines/Naming/#_conflicting_package_names


===== MUST items =====

Generic:
[ ]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
     Note: Using prebuilt packages
[ ]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[ ]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Unknown or generated", "*No copyright* Artistic License 2.0",
     "*No copyright* MIT License ISC License", "MIT License ISC License",
     "*No copyright* ISC License", "*No copyright* MIT License", "MIT
     License", "ISC License", "BSD 2-Clause License", "*No copyright* BSD
     2-Clause License", "BSD 3-Clause License", "*No copyright* BSD
     3-Clause License", "MIT License Do What The Fuck You Want To Public
     License, Version 2", "*No copyright* Apache License 2.0", "Apache
     License 2.0", "*No copyright* Creative Commons Attribution 3.0", "*No
     copyright* Creative Commons CC0 1.0", "*No copyright* [generated
     file]". 2395 files have unknown license. Detailed output of
     licensecheck in /var/lib/copr-rpmbuild/results/npm/licensecheck.txt
[ ]: If the package is under multiple licenses, the licensing breakdown
     must be documented in the spec.
[ ]: Package requires other packages for directories it uses.
     Note: No known owner of /usr/etc
[ ]: Package must own all directories that it creates.
     Note: Directories without known owners: /usr/etc
[ ]: Package contains no bundled libraries without FPC exception.
[ ]: Changelog in prescribed format.
[ ]: Sources contain only permissible code or content.
[ ]: Package contains desktop file if it is a GUI application.
[ ]: Development files must be in a -devel package
[ ]: Package uses nothing in %doc for runtime.
[ ]: Package consistently uses macros (instead of hard-coded directory
     names).
[ ]: Package is named according to the Package Naming Guidelines.
[ ]: Package does not generate any conflict.
[ ]: Package obeys FHS, except libexecdir and /usr/target.
[ ]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[ ]: Requires correct, justified where necessary.
[ ]: Spec file is legible and written in American English.
[ ]: Package contains systemd file(s) if in need.
[ ]: Package is not known to require an ExcludeArch tag.
[ ]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 1 files.
[ ]: Package complies to the Packaging Guidelines
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package must not depend on deprecated() packages.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[!]: Reviewer should test that the package builds in mock.
[ ]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[ ]: Final provides and requires are sane (see attachments).
[ ]: Package functions as described.
[ ]: Latest version is packaged.
[ ]: Package does not include license text files separate from upstream.
[ ]: Sources are verified with gpgverify first in %prep if upstream
     publishes signatures.
     Note: gpgverify is not used.
[ ]: Package should compile and build into binary rpms on all supported
     architectures.
[ ]: %check is present and all tests pass.
[ ]: Packages should try to preserve timestamps of original installed
     files.
[ ]: Spec use %global instead of %define unless justified.
     Note: %define requiring justification: %define autorelease(e:s:pb:)
     %{?-p:0.}%{lua:
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).


Rpmlint
-------
Cannot parse rpmlint output:


Rpmlint (installed packages)
----------------------------
Cannot parse rpmlint output:


Source checksums
----------------
https://registry.npmjs.org/npm/-/npm-8.6.0.tgz :
  CHECKSUM(SHA256) this package     : d1cc0bc97f58f65b4acd8d7bcae71a26bc2849982f1b6a7ede63efbb07f9cd58
  CHECKSUM(SHA256) upstream package : d1cc0bc97f58f65b4acd8d7bcae71a26bc2849982f1b6a7ede63efbb07f9cd58


Requires
--------
npm (rpmlib, GLIBC filtered):
    /usr/bin/node
    /usr/bin/sh



Provides
--------
npm:
    bundled(nodejs-@gar/promisify)
    bundled(nodejs-@isaacs/string-locale-compare)
    bundled(nodejs-@npmcli/arborist)
    bundled(nodejs-@npmcli/ci-detect)
    bundled(nodejs-@npmcli/config)
    bundled(nodejs-@npmcli/disparity-colors)
    bundled(nodejs-@npmcli/fs)
    bundled(nodejs-@npmcli/git)
    bundled(nodejs-@npmcli/installed-package-contents)
    bundled(nodejs-@npmcli/map-workspaces)
    bundled(nodejs-@npmcli/metavuln-calculator)
    bundled(nodejs-@npmcli/move-file)
    bundled(nodejs-@npmcli/name-from-folder)
    bundled(nodejs-@npmcli/node-gyp)
    bundled(nodejs-@npmcli/package-json)
    bundled(nodejs-@npmcli/promise-spawn)
    bundled(nodejs-@npmcli/run-script)
    bundled(nodejs-@tootallnate/once)
    bundled(nodejs-abbrev)
    bundled(nodejs-agent-base)
    bundled(nodejs-agentkeepalive)
    bundled(nodejs-aggregate-error)
    bundled(nodejs-ansi-regex)
    bundled(nodejs-ansi-styles)
    bundled(nodejs-ansicolors)
    bundled(nodejs-ansistyles)
    bundled(nodejs-aproba)
    bundled(nodejs-archy)
    bundled(nodejs-are-we-there-yet)
    bundled(nodejs-asap)
    bundled(nodejs-balanced-match)
    bundled(nodejs-bin-links)
    bundled(nodejs-binary-extensions)
    bundled(nodejs-brace-expansion)
    bundled(nodejs-builtins)
    bundled(nodejs-cacache)
    bundled(nodejs-chalk)
    bundled(nodejs-chownr)
    bundled(nodejs-cidr-regex)
    bundled(nodejs-clean-stack)
    bundled(nodejs-cli-columns)
    bundled(nodejs-cli-table3)
    bundled(nodejs-clone)
    bundled(nodejs-cmd-shim)
    bundled(nodejs-color-convert)
    bundled(nodejs-color-name)
    bundled(nodejs-color-support)
    bundled(nodejs-columnify)
    bundled(nodejs-common-ancestor-path)
    bundled(nodejs-concat-map)
    bundled(nodejs-console-control-strings)
    bundled(nodejs-debug)
    bundled(nodejs-debuglog)
    bundled(nodejs-defaults)
    bundled(nodejs-delegates)
    bundled(nodejs-depd)
    bundled(nodejs-dezalgo)
    bundled(nodejs-diff)
    bundled(nodejs-emoji-regex)
    bundled(nodejs-env-paths)
    bundled(nodejs-err-code)
    bundled(nodejs-fastest-levenshtein)
    bundled(nodejs-fs-minipass)
    bundled(nodejs-fs.realpath)
    bundled(nodejs-function-bind)
    bundled(nodejs-gauge)
    bundled(nodejs-glob)
    bundled(nodejs-graceful-fs)
    bundled(nodejs-has)
    bundled(nodejs-has-flag)
    bundled(nodejs-has-unicode)
    bundled(nodejs-hosted-git-info)
    bundled(nodejs-http-cache-semantics)
    bundled(nodejs-http-proxy-agent)
    bundled(nodejs-https-proxy-agent)
    bundled(nodejs-humanize-ms)
    bundled(nodejs-ignore-walk)
    bundled(nodejs-imurmurhash)
    bundled(nodejs-indent-string)
    bundled(nodejs-infer-owner)
    bundled(nodejs-inflight)
    bundled(nodejs-inherits)
    bundled(nodejs-ini)
    bundled(nodejs-init-package-json)
    bundled(nodejs-ip)
    bundled(nodejs-ip-regex)
    bundled(nodejs-is-cidr)
    bundled(nodejs-is-core-module)
    bundled(nodejs-is-fullwidth-code-point)
    bundled(nodejs-is-lambda)
    bundled(nodejs-isexe)
    bundled(nodejs-json-parse-even-better-errors)
    bundled(nodejs-json-stringify-nice)
    bundled(nodejs-jsonparse)
    bundled(nodejs-just-diff)
    bundled(nodejs-just-diff-apply)
    bundled(nodejs-libnpmaccess)
    bundled(nodejs-libnpmdiff)
    bundled(nodejs-libnpmexec)
    bundled(nodejs-libnpmfund)
    bundled(nodejs-libnpmhook)
    bundled(nodejs-libnpmorg)
    bundled(nodejs-libnpmpack)
    bundled(nodejs-libnpmpublish)
    bundled(nodejs-libnpmsearch)
    bundled(nodejs-libnpmteam)
    bundled(nodejs-libnpmversion)
    bundled(nodejs-lru-cache)
    bundled(nodejs-make-fetch-happen)
    bundled(nodejs-minimatch)
    bundled(nodejs-minipass)
    bundled(nodejs-minipass-collect)
    bundled(nodejs-minipass-fetch)
    bundled(nodejs-minipass-flush)
    bundled(nodejs-minipass-json-stream)
    bundled(nodejs-minipass-pipeline)
    bundled(nodejs-minipass-sized)
    bundled(nodejs-minizlib)
    bundled(nodejs-mkdirp)
    bundled(nodejs-mkdirp-infer-owner)
    bundled(nodejs-ms)
    bundled(nodejs-mute-stream)
    bundled(nodejs-negotiator)
    bundled(nodejs-node-gyp)
    bundled(nodejs-nopt)
    bundled(nodejs-normalize-package-data)
    bundled(nodejs-npm-audit-report)
    bundled(nodejs-npm-bundled)
    bundled(nodejs-npm-install-checks)
    bundled(nodejs-npm-normalize-package-bin)
    bundled(nodejs-npm-package-arg)
    bundled(nodejs-npm-packlist)
    bundled(nodejs-npm-pick-manifest)
    bundled(nodejs-npm-profile)
    bundled(nodejs-npm-registry-fetch)
    bundled(nodejs-npm-user-validate)
    bundled(nodejs-npmlog)
    bundled(nodejs-once)
    bundled(nodejs-opener)
    bundled(nodejs-p-map)
    bundled(nodejs-pacote)
    bundled(nodejs-parse-conflict-json)
    bundled(nodejs-path-is-absolute)
    bundled(nodejs-proc-log)
    bundled(nodejs-promise-all-reject-late)
    bundled(nodejs-promise-call-limit)
    bundled(nodejs-promise-inflight)
    bundled(nodejs-promise-retry)
    bundled(nodejs-promzard)
    bundled(nodejs-qrcode-terminal)
    bundled(nodejs-read)
    bundled(nodejs-read-cmd-shim)
    bundled(nodejs-read-package-json)
    bundled(nodejs-read-package-json-fast)
    bundled(nodejs-readable-stream)
    bundled(nodejs-readdir-scoped-modules)
    bundled(nodejs-retry)
    bundled(nodejs-rimraf)
    bundled(nodejs-safe-buffer)
    bundled(nodejs-semver)
    bundled(nodejs-set-blocking)
    bundled(nodejs-signal-exit)
    bundled(nodejs-smart-buffer)
    bundled(nodejs-socks)
    bundled(nodejs-socks-proxy-agent)
    bundled(nodejs-spdx-correct)
    bundled(nodejs-spdx-exceptions)
    bundled(nodejs-spdx-expression-parse)
    bundled(nodejs-spdx-license-ids)
    bundled(nodejs-ssri)
    bundled(nodejs-string-width)
    bundled(nodejs-string_decoder)
    bundled(nodejs-stringify-package)
    bundled(nodejs-strip-ansi)
    bundled(nodejs-supports-color)
    bundled(nodejs-tar)
    bundled(nodejs-text-table)
    bundled(nodejs-tiny-relative-date)
    bundled(nodejs-treeverse)
    bundled(nodejs-unique-filename)
    bundled(nodejs-unique-slug)
    bundled(nodejs-util-deprecate)
    bundled(nodejs-validate-npm-package-license)
    bundled(nodejs-validate-npm-package-name)
    bundled(nodejs-walk-up-path)
    bundled(nodejs-wcwidth)
    bundled(nodejs-which)
    bundled(nodejs-wide-align)
    bundled(nodejs-wrappy)
    bundled(nodejs-write-file-atomic)
    bundled(nodejs-yallist)
    npm
    npm(npm)



Generated by fedora-review 0.8.0 (e988316) last change: 2022-04-07
Command line :/usr/bin/fedora-review --no-colors --prebuilt --rpm-spec --name npm --mock-config /var/lib/copr-rpmbuild/results/configs/child.cfg
Buildroot used: fedora-rawhide-x86_64
Active plugins: Shell-api, Generic
Disabled plugins: PHP, C/C++, Haskell, Perl, SugarActivity, R, Ocaml, Python, fonts, Java
Disabled flags: EPEL6, EPEL7, DISTTAG, BATCH, EXARCH

Comment 2 Neal Gompa 2022-04-13 19:33:28 UTC
Taking this review.

Comment 4 Neal Gompa 2022-04-28 23:31:19 UTC
> I updated to 8.8.0, switched to using the %forge macros and created a shell script to handle the bundling needs.

Please don't use the forge macros, they're completely unmaintained and only exist because the Go macros are hardwired into them.

Comment 6 Neal Gompa 2022-08-02 13:15:32 UTC
Package review notes:

* Package naming and versioning is sane
* Package correctly replaces existing packages
* Package builds and installs
* Package licensing is correct

I'm not sure you want the vendored %autorelease macro, but otherwise it looks good.

PACKAGE APPROVED.

Comment 7 Stephen Gallagher 2022-11-14 18:35:17 UTC
We've decided not to carry this package after all.


Note You need to log in before you can comment on or make changes to this bug.